import sys
import os
import re
import common
forge = sys.modules["forge"]

def setup(module):
	for boost_source in forge.boost_sources:
		if not os.path.exists(boost_source[2]) or not os.path.exists(boost_source[3]):
			sys.stdout.write("-" + boost_source[0] + " ")
			continue

		boost_lib = common.find_boost_lib(boost_source[1], boost_source[3], 'regex')
		if boost_lib == '':
			sys.stdout.write("-" + boost_source[0] + " ")
			continue

		if boost_source[0] == "":
			sys.stdout.write("/ ")
		else:
			sys.stdout.write(boost_source[0] + " ")

#		sys.stdout.write(boost_lib + " ")

		srcList = [	"boostregex.pmh",
					"boostregexDL" ]

		variant = boost_source[0]
		if variant != "":
			variantPath = module.modPath + '/' + variant
			if os.path.lexists(variantPath) == 0:
				os.symlink('.', variantPath)

			srcListVariant = []
			for src in srcList:
				srcListVariant += [ variant + '/' + src ]
			srcList = srcListVariant

		dllname = "fexBoostRegex" + variant

		dll = module.DLL( dllname, srcList )

		for src in srcList:
			relativePath = forge.RelativePath(forge.rootPath,module.modPath)
			modObjPath = os.path.join(forge.objPath, relativePath)
			objName = modObjPath + '/' + src
			if re.compile(r'(.*)\.pmh$').match(src):
				objName += '.gch'
			else:
				objName += forge.objsuf
			srcTarget = forge.FindTarget(objName)
			srcTarget.includemap = { 'boostregex' : boost_source[2] }

		dll.linkmap = { "boostregex" :
				"-L" + boost_source[3] + ' -l' + boost_lib }
		if boost_source[0] == '':
			dll.linkmap["boostregex"] += ' -Xlinker -rpath ' + boost_source[3]

		deplibs = [ "fePlatformLib" ]

		forge.deps( [ dllname + "Lib" ], deplibs )
