/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "terminal.pmh"
#include "platform/dlCore.cc"

static fe::sp<fe::Master> gs_master;
static fe::sp<fe::Terminal> gs_terminal;

extern "C"
{

FE_DL_EXPORT int fe_terminal_execute(
		int a_outputSize,char* a_output,const char* a_input)
{
//	printf("::fe_terminal_execute \"%s\"\n",a_input);

	if(gs_master.isNull())
	{
		gs_master=new fe::Master();
		gs_master->registry()->manage("fexTerminalDL");
	}
	if(gs_master.isValid() && gs_terminal.isNull())
	{
		gs_terminal=gs_master->registry()->create("*.Terminal");
	}
	if(gs_terminal.isValid())
	{
		fe::String result=gs_terminal->execute(a_input);
		strncpy(a_output,result.c_str(),a_outputSize);
		return 1;
	}

	return 0;
}

FE_DL_EXPORT void ListDependencies(fe::List<fe::String*>& list)
{
	list.append(new fe::String("feSignalDL"));
}

FE_DL_EXPORT fe::Library* CreateLibrary(fe::sp<fe::Master>)
{
	fe::Library *pLibrary = new fe::Library();

	pLibrary->add<fe::Terminal>("Component.Terminal.fe");

	return pLibrary;
}

}
